<#--
This FreeMarker code is designed to be used with
Statestep models which contain embedded Perl code.
See the HTML documentation for more about this.
-->

=pod

=head2 extralogic()

Code extracted from the rules of the model.
Given a current state, event, rule, and a next state,
run any any Perl code embedded in the rule formula;
then return either the next state passed in,
or an altered next state, or, to indicate that the
rule should not apply, C<undef>.

This can be passed to the C<apply_rules()> method
of the C<Combination> class.

=cut

sub extralogic {
    my ($current, $event, $rule, $next) = @_;
    <@code_for_rules/><#lt>
    return $next;
}

1;

<#--
For every rule in the model:
If executable code  for the rule is embedded in a comment
then output an 'if' statement to test for that particular
rule followed by the code extracted from the rule.
-->
<#macro code_for_rules>
    <#-- true until the first 'if' statement is written -->
    <#local first = true/>
    <#list doc.model.events.event as event>
        <#list event.rules.rule as rule>
            <#if rule.formula[0]?exists>
                <#local code_lines =
                rule.formula.text?matches("#:(.*)")
                />
                <#if code_lines?size != 0>
                    <#t>    # Event ${event.@name},
                    <#lt> rule ${rule.@name}
                    <#t>    <#if !first>els</#if>
                    <#t>if ($event == ${event_index}
                    <#lt> && $rule == ${rule_index}) {
                    <#list code_lines as line>
                        <#t>        <#t>
                        <#lt>${line?groups[1]}
                    </#list>
                    <#lt>    }
                    <#local first = false/>
                </#if>
            </#if>
        </#list>
    </#list>
</#macro>
