#!/usr/bin/env perl
# Check that the text of formulas is correctly generated.
# This code is designed to test only the formulas.s2 model.
# The Perl module generated from the same model using the
# main template should be specified using the -M option on
# the command line.

use 5.008008;
use warnings;
use strict;

sub check {
   die "got: $_[0]\nexp: $_[1]\n" unless $_[0] eq $_[1];
}

# global constraint formulas
check($Constraint_Texts[-1][0], '# "< \\& \\\'dummy\\\\ 1
# \'\\ >"\\');
check($Constraint_Texts[-1][1], '# g2
A = {*}');

# event constraints
die if @{$Constraint_Texts[0]};

check($Constraint_Texts[1][0], 'A={a2}=>B={b2}');
check($Constraint_Texts[1][1], '');
check($Constraint_Texts[1][2], '# "<\'>&');

check($Constraint_Texts[2][0], '');
check($Constraint_Texts[2][1], '# ev2c1');

# rule formulas
die if @{$Rule_Texts[0]};

check($Rule_Texts[1][0], '!B={b2}
# \'\'\' This is my formula comment
# containing """ and \'\'\'\'\'\'
#');
check($Rule_Texts[1][1], '');

check($Rule_Texts[2][0], '');
check($Rule_Texts[2][1], '# r2 \\\'\\\\\'\\\\\\\'');
check($Rule_Texts[2][2], '# r3
# formula');
